org.apache.fop.area

## Class Trait

- java.lang.Object
- - org.apache.fop.area.Trait

- All Implemented Interfaces:
    java.io.Serializable

      public final class Trait
      extends java.lang.Object
      implements java.io.Serializable

  Area traits used for rendering. This class represents an area trait that specifies a value for rendering.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Trait.Background` Background trait structure.
    `static class` | `Trait.ExternalLink` External Link trait structure
    `static class` | `Trait.InternalLink` Class for internal link traits.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.Integer` | `BACKGROUND` Background trait for an area.
    `static java.lang.Integer` | `BLINK` Blinking trait used when rendering inline parent.
    `static java.lang.Integer` | `BLOCK_PROGRESSION_DIRECTION` block progression direction trait
    `static java.lang.Integer` | `BORDER_AFTER` The border after.
    `static java.lang.Integer` | `BORDER_BEFORE` The border before.
    `static java.lang.Integer` | `BORDER_END` The border end.
    `static java.lang.Integer` | `BORDER_START` The border start.
    `static java.lang.Integer` | `COLOR` The current color.
    `static java.lang.Integer` | `COLUMN_PROGRESSION_DIRECTION` column progression direction trait
    `static java.lang.Integer` | `END_INDENT` The end-indent trait.
    `static java.lang.Integer` | `EXTERNAL_LINK` External link.
    `static java.lang.Integer` | `FONT` The font triplet for the current font.
    `static java.lang.Integer` | `FONT_SIZE` Font size for the current font.
    `static java.lang.Integer` | `INLINE_PROGRESSION_DIRECTION` inline progression direction trait
    `static java.lang.Integer` | `INTERNAL_LINK` Internal link trait.
    `static java.lang.Integer` | `IS_REFERENCE_AREA` The is-reference-area trait.
    `static java.lang.Integer` | `IS_VIEWPORT_AREA` The is-viewport-area trait.
    `static java.lang.Integer` | `LAYER` For optional content groups.
    `static java.lang.Integer` | `LINETHROUGH` Linethrough trait used when rendering inline parent.
    `static java.lang.Integer` | `LINETHROUGH_COLOR` Trait for color of linethrough decorations when rendering inline parent.
    `static int` | `MAX_TRAIT_KEY` Maximum value used by trait keys
    `static java.lang.Integer` | `OVERLINE` Overline trait used when rendering inline parent.
    `static java.lang.Integer` | `OVERLINE_COLOR` Trait for color of overline decorations when rendering inline parent.
    `static java.lang.Integer` | `PADDING_AFTER` The padding after.
    `static java.lang.Integer` | `PADDING_BEFORE` The padding before.
    `static java.lang.Integer` | `PADDING_END` The padding end.
    `static java.lang.Integer` | `PADDING_START` The padding start.
    `static java.lang.Integer` | `PROD_ID` The ID of the FO that produced an area.
    `static java.lang.Integer` | `SHIFT_DIRECTION` shift direction trait
    `static java.lang.Integer` | `SPACE_AFTER` The space-after trait.
    `static java.lang.Integer` | `SPACE_BEFORE` The space-before trait.
    `static java.lang.Integer` | `SPACE_END` The space end.
    `static java.lang.Integer` | `SPACE_START` The space start.
    `static java.lang.Integer` | `START_INDENT` The start-indent trait.
    `static java.lang.Integer` | `STRUCTURE_TREE_ELEMENT` For navigation in the document structure.
    `static java.lang.Integer` | `UNDERLINE` Underline trait used when rendering inline parent.
    `static java.lang.Integer` | `UNDERLINE_COLOR` Trait for color of underline decorations when rendering inline parent.
    `static java.lang.Integer` | `VISIBILITY` Used to disable the rendering of a Block http://www.w3.org/TR/xsl/#rend-vis
    `static java.lang.Integer` | `WRITING_MODE` writing mode trait

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.Class` | `getTraitClass(java.lang.Object traitCode)` Get the data storage class for the trait.
    `static java.lang.String` | `getTraitName(java.lang.Object traitCode)` Get the trait name for a trait code.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### INTERNAL_LINK

          public static final java.lang.Integer INTERNAL_LINK

      Internal link trait. Contains the PageViewport key and the PROD_ID of the target area

    - #### EXTERNAL_LINK

          public static final java.lang.Integer EXTERNAL_LINK

      External link. A URL link to an external resource.

    - #### FONT

          public static final java.lang.Integer FONT

      The font triplet for the current font.

    - #### FONT_SIZE

          public static final java.lang.Integer FONT_SIZE

      Font size for the current font.

    - #### COLOR

          public static final java.lang.Integer COLOR

      The current color.

    - #### PROD_ID

          public static final java.lang.Integer PROD_ID

      The ID of the FO that produced an area.

    - #### BACKGROUND

          public static final java.lang.Integer BACKGROUND

      Background trait for an area.

    - #### UNDERLINE

          public static final java.lang.Integer UNDERLINE

      Underline trait used when rendering inline parent.

    - #### OVERLINE

          public static final java.lang.Integer OVERLINE

      Overline trait used when rendering inline parent.

    - #### LINETHROUGH

          public static final java.lang.Integer LINETHROUGH

      Linethrough trait used when rendering inline parent.

    - #### BORDER_START

          public static final java.lang.Integer BORDER_START

      The border start.

    - #### BORDER_END

          public static final java.lang.Integer BORDER_END

      The border end.

    - #### BORDER_BEFORE

          public static final java.lang.Integer BORDER_BEFORE

      The border before.

    - #### BORDER_AFTER

          public static final java.lang.Integer BORDER_AFTER

      The border after.

    - #### PADDING_START

          public static final java.lang.Integer PADDING_START

      The padding start.

    - #### PADDING_END

          public static final java.lang.Integer PADDING_END

      The padding end.

    - #### PADDING_BEFORE

          public static final java.lang.Integer PADDING_BEFORE

      The padding before.

    - #### PADDING_AFTER

          public static final java.lang.Integer PADDING_AFTER

      The padding after.

    - #### SPACE_START

          public static final java.lang.Integer SPACE_START

      The space start.

    - #### SPACE_END

          public static final java.lang.Integer SPACE_END

      The space end.

    - #### START_INDENT

          public static final java.lang.Integer START_INDENT

      The start-indent trait.

    - #### END_INDENT

          public static final java.lang.Integer END_INDENT

      The end-indent trait.

    - #### SPACE_BEFORE

          public static final java.lang.Integer SPACE_BEFORE

      The space-before trait.

    - #### SPACE_AFTER

          public static final java.lang.Integer SPACE_AFTER

      The space-after trait.

    - #### IS_REFERENCE_AREA

          public static final java.lang.Integer IS_REFERENCE_AREA

      The is-reference-area trait.

    - #### IS_VIEWPORT_AREA

          public static final java.lang.Integer IS_VIEWPORT_AREA

      The is-viewport-area trait.

    - #### BLINK

          public static final java.lang.Integer BLINK

      Blinking trait used when rendering inline parent.

    - #### UNDERLINE_COLOR

          public static final java.lang.Integer UNDERLINE_COLOR

      Trait for color of underline decorations when rendering inline parent.

    - #### OVERLINE_COLOR

          public static final java.lang.Integer OVERLINE_COLOR

      Trait for color of overline decorations when rendering inline parent.

    - #### LINETHROUGH_COLOR

          public static final java.lang.Integer LINETHROUGH_COLOR

      Trait for color of linethrough decorations when rendering inline parent.

    - #### STRUCTURE_TREE_ELEMENT

          public static final java.lang.Integer STRUCTURE_TREE_ELEMENT

      For navigation in the document structure.

    - #### WRITING_MODE

          public static final java.lang.Integer WRITING_MODE

      writing mode trait

    - #### INLINE_PROGRESSION_DIRECTION

          public static final java.lang.Integer INLINE_PROGRESSION_DIRECTION

      inline progression direction trait

    - #### BLOCK_PROGRESSION_DIRECTION

          public static final java.lang.Integer BLOCK_PROGRESSION_DIRECTION

      block progression direction trait

    - #### COLUMN_PROGRESSION_DIRECTION

          public static final java.lang.Integer COLUMN_PROGRESSION_DIRECTION

      column progression direction trait

    - #### SHIFT_DIRECTION

          public static final java.lang.Integer SHIFT_DIRECTION

      shift direction trait

    - #### LAYER

          public static final java.lang.Integer LAYER

      For optional content groups.

    - #### VISIBILITY

          public static final java.lang.Integer VISIBILITY

      Used to disable the rendering of a Block http://www.w3.org/TR/xsl/#rend-vis

    - #### MAX_TRAIT_KEY

          public static final int MAX_TRAIT_KEY

      Maximum value used by trait keys
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getTraitName

          public static java.lang.String getTraitName(java.lang.Object traitCode)

      Get the trait name for a trait code.
      Parameters:
        `traitCode` - the trait code to get the name for
      Returns:
        the trait name

    - #### getTraitClass

          public static java.lang.Class getTraitClass(java.lang.Object traitCode)

      Get the data storage class for the trait.
      Parameters:
        `traitCode` - the trait code to lookup
      Returns:
        the class type for the trait

Copyright 1999-2021 The Apache Software Foundation. All Rights Reserved.